<?php

/**
 * Class d3_oxemail_payremind
 */
class d3_oxemail_payremind extends d3_oxemail_payremind_parent
{
    protected $_d3oOrder;

    /**
     * @param $oOrder   oxOrder
     * @param $sSubject string
     *
     * @return bool
     */
    public function d3sendPayRemind($oOrder, $sSubject = null)
    {
        $this->_d3oOrder = $oOrder;

        // User
        $oUser = oxNew('oxuser');
        $oUser->load($oOrder->oxorder__oxuserid->value);

        // Shop
        $oShop = $this->_getShop($oOrder->getOrderLanguage(), $oOrder->getFieldData('oxshopid'));

        if ($oOrder instanceof oxOrder && $oUser instanceof oxUser && $oShop instanceof oxShop) {

            $this->_setMailParams($oShop);
            $this->setViewData("order", $oOrder);
            $this->setViewData("shopTemplateDir", oxRegistry::getConfig()->getTemplateDir(false));

            if (oxRegistry::getConfig()->getConfigParam("bl_perfLoadReviews")) {
                $this->setViewData("blShowReviewLink", true);
                $this->setViewData(
                    "reviewuserhash",
                    $oUser->getReviewUserHash($oOrder->oxorder__oxuserid->value)
                );
            }

            // Process view data array through oxoutput processor
            $this->_processViewArray();
            $oSmarty  = $this->_getSmarty();
            $oHandler = oxNew('d3_transferform_application_models_handler', $oOrder, $oUser, $oShop, $this);

            return $oHandler->d3sendPayRemind($oSmarty, $sSubject);
        }

        return false;
    }

    /**
     * Gibt den Formatierten Wert xx,xx vom bergebenen Wert (Preis) zurck
     *
     * @param $price
     *
     * @return string
     */
    public function d3getFormattedPrice($price)
    {
        return oxRegistry::getLang()->formatCurrency($price, $this->_d3oOrder->getOrderCurrency());
    }
}
